//+------------------------------------------------------------------+
//|                                                                  |
//|                      2008 Sunwest                                |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright                              "2008 Sunwest"
#property  link                         "Forex-tsd.com"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property indicator_color1 Blue      
#property indicator_color2 Red
#property indicator_color3 Green



//---- buffers
double BarUp[];
double BarDown[];
double DaySeparator[];

extern int PipStep = 40;
extern bool StopDisplay = true;

int HourinDay = 24;
double MaxUpDistance,MxDownDistance,Max;
double Diff,Diffmax,Diffmin;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,2);
   
   SetIndexBuffer(0,BarUp);
   SetIndexBuffer(1,BarDown);
   SetIndexBuffer(2,DaySeparator);

   SetLevelStyle(STYLE_DASHDOTDOT,0,Brown);
   SetLevelValue(3,PipStep);
   SetLevelValue(4,-PipStep);
  


//---- initialization done
   return(0);
  }

int start()
  {
  //int counted_bars=IndicatorCounted();
   
      //int Hshift = HourinDay+StartHour-TimeHour(Time[Bars-1]);
      //Print("Hour of first Bar",TimeHour(Time[Bars-1]));
      //Print("Hshift",Hshift);
      
      for(int shift = Bars-HourinDay-1; shift >= 0; shift-=HourinDay)
      { 

         MaxUpDistance = 0;
         MxDownDistance = 0;
         Max=0;
         DaySeparator[shift]=200;
         for(int i =0 ; i < HourinDay  ; i++)
         {
            Diffmax = High[shift-i]-Open[shift];
            Diffmin = Low[shift-i]-Open[shift];
            
            if (Diffmax > MaxUpDistance) MaxUpDistance=Diffmax;
            if (Diffmin<  MxDownDistance) MxDownDistance=Diffmin;
            
            if ( MaxUpDistance> MathAbs(MxDownDistance))   Max=MaxUpDistance; else Max= MxDownDistance;

            
            if (Max>=0)   
            {
               if( (StopDisplay==true) && (Max/Point >=PipStep)) StopDisplay=true; else BarUp[shift-i]= Max/Point; 
            }
            else 
            {
               if( (StopDisplay==true) && (Max/Point <=-PipStep)) StopDisplay=true; else BarDown[shift-i] = Max/Point;
            }
               
            if ( TimeHour(Time[shift-i])!= TimeHour(Time[shift-i-1])-1) {shift=shift+HourinDay-i-1;i=HourinDay;}

            //Print("Hour of first Bar",TimeHour(Time[shift-i])," Next Hour ",TimeHour(Time[shift-i-1]));
            
         }
      }
      
      return(0);
  }
//+------------------------------------------------------------------+